package addBk.print.labels;


import javax.print.PrintService;
import java.awt.*;
import java.awt.print.*;

public class DymoPrinter implements Printable {

    public static void main(String[] args) {
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        PrintService[] printService = PrinterJob.lookupPrintServices();
        for (int i = 0; i < printService.length; i++) {
            System.out.println(printService[i].getName());
        }
        PageFormat pageFormat = printerJob.defaultPage();
        Paper paper = new Paper();
        int w=(int)3.5*72;
        int h = (int)1.25 *72;
        paper.setSize(w, h);
        paper.setImageableArea(20, 20, w-20, h-20);
        pageFormat.setOrientation(PageFormat.LANDSCAPE);
        pageFormat.setPaper(paper);
        //printerJob.setPrintable()
        if (printerJob.pageDialog(pageFormat) != pageFormat) {
            // User has okayed their settings
            // Let the user select the print options
            if (printerJob.printDialog()) {
                printerJob.setPrintable(new DymoPrinter());
                try {
                    printerJob.print();
                } catch (PrinterException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
        }
        System.exit(0);
    }

    public int print(Graphics graphics,
                     PageFormat pageFormat,
                     int pageIndex) throws PrinterException {
        graphics.setClip(0, 0, 612, 792);
        if (pageIndex == 0) {
            System.out.println("imageable X      = " +
                    pageFormat.getImageableX());
            System.out.println("imageable Y      = " +
                    pageFormat.getImageableY());
            System.out.println("imageable Width  = " +
                    pageFormat.getImageableWidth());
            System.out.println("imageable Height = " +
                    pageFormat.getImageableHeight());
            Graphics2D g = (Graphics2D) graphics;
            // g.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
            g.translate(20, 20);
            g.drawString("Creo Proofer Label", 20.0f, 20.0f);
            //g.drawString("1111", -50.0f, -50.0f);
            //g.drawString("2222", -50.0f,  50.0f);
            //g.drawString("3333",  50.0f, -50.0f);
            g.drawString("4444", 50.0f, 50.0f);
            return PAGE_EXISTS;
        } else
            return NO_SUCH_PAGE;
    }
}

